//       MMM2.mq4, 
//----   yuzefovich@gmail.com
#property copyright "Bookkeeper, 2006"
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Magenta
#property indicator_color2  Magenta
#property indicator_color3  Blue
#property indicator_color4  Black

extern int FirstWorkHour =7; // Asia =1, Eur =7, USA =14
extern int LastWorkHour =15;  // Asia =9 (10:00), Eur =15 (16:00), USA =22 (23:00)

int ExtCountedBars=0, Shift=0; 
bool first=True;

double  Lw_Bufer[];
double  Hgh_Bufer[];
double  SMA_Bufer[];
double  SumMdl_Bufer[];

//+------------------------------------------------------------------+
int init()
{
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(0,Lw_Bufer);
   SetIndexBuffer(1,Hgh_Bufer);
   SetIndexBuffer(2,SMA_Bufer);
   SetIndexBuffer(3,SumMdl_Bufer);
   return(0);
}
//+------------------------------------------------------------------+
int start()
{
int    curPeriod=0, nMdl;
   if (FirstWorkHour < 0) return(-1); // ,  
   if (LastWorkHour > 23) return(-1);
   if (FirstWorkHour > LastWorkHour) return(-1);
   if (curPeriod!=Period()) first=True; //     -    
   if (first==True)  //   FirstWorkHour  
   {
      Shift = Bars-1;
      curPeriod=Period();
      if (curPeriod>30) return(-1); //   ,   
      while (first==True) 
      {
         Shift--;
         if(TimeHour(Time[Shift])==FirstWorkHour && 
            TimeHour(Time[Shift+1])!=FirstWorkHour) 
         {   
            first = False; // 
            Lw_Bufer[Shift] = Low[Shift];
            Hgh_Bufer[Shift] = High[Shift];
            SumMdl_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
            nMdl=Shift;
            SMA_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
         }   
         if (Shift< 2) return(-1); //  ...
      } 
   } 
   else //   FirstWorkHour    -  - 
   {
      ExtCountedBars=IndicatorCounted();
      if (ExtCountedBars<0) return(-1);
      if (ExtCountedBars>0) ExtCountedBars--;
      Shift = Bars-ExtCountedBars-1;
   } 
   while (Shift > 0) // , 
   {
      if(TimeHour(Time[Shift]) == FirstWorkHour && 
         TimeHour(Time[Shift+1]) != FirstWorkHour) //   
      {
         Lw_Bufer[Shift] = Low[Shift];
         Hgh_Bufer[Shift] = High[Shift];
         SumMdl_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
         nMdl=Shift;
         SMA_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
         Shift--;
      } 
      else //   
      {
         while((TimeHour(Time[Shift])>=FirstWorkHour) && 
               (TimeHour(Time[Shift])<=LastWorkHour) && (Shift>0))
         {
            if(Lw_Bufer[Shift+1] > Low[Shift]) Lw_Bufer[Shift] = Low[Shift];
            else Lw_Bufer[Shift] = Lw_Bufer[Shift+1];
            if(Hgh_Bufer[Shift+1] < High[Shift]) Hgh_Bufer[Shift] = High[Shift];
            else Hgh_Bufer[Shift] = Hgh_Bufer[Shift+1];
            SumMdl_Bufer[Shift] = SumMdl_Bufer[Shift+1]+(Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2;
            SMA_Bufer[Shift] = SumMdl_Bufer[Shift]/(nMdl-Shift+1);  //      
//         SMA_Bufer[Shift] = (Lw_Bufer[Shift]+Hgh_Bufer[Shift])/2; //    
            Shift--;
         }
      } 
      while(((TimeHour(Time[Shift])<FirstWorkHour) || 
             (TimeHour(Time[Shift])>LastWorkHour)) && 
             (Shift>0))                                //   
      {
         Shift--;                        
         SumMdl_Bufer[Shift] = EMPTY_VALUE;
         SMA_Bufer[Shift] = EMPTY_VALUE;
         Hgh_Bufer[Shift] = EMPTY_VALUE;
         Lw_Bufer[Shift] = EMPTY_VALUE;
      }
   }
   return(0);
}

